<?php

/**
 * Class manufactoryProductCosts
 */
abstract class manufactoryEntityCosts extends manufactoryEntityProductStorage implements manufactoryEntityCostsInterface, ArrayAccess, IteratorAggregate
{


    public function save()
    {
        $this->getFactory('Costs')
            ->getType($this->getEntityType())
            ->setByEntity($this->getEntity(), $this->data);
    }

    public function delete()
    {
        $this->getFactory('Costs')
            ->getType($this->getEntityType())
            ->deleteByEntity($this->getEntity());
    }

    public function setData($data = array(), $key = null)
    {
        return parent::setData($data, $key); // TODO: Change the autogenerated stub
    }

    public function getObjects()
    {
        $type = $this->getFactory('Costs')
            ->getType($this->getEntityType());
        $data = array();
        foreach ($this->data as $k => $v) {
            if (!is_object($v) || !($v instanceof manufactoryCostEntity)) {
                $data[$k] = $type->buildEntityCost($this->getEntity(), array('cost_id' => $k, 'quantity' => $v));
            }
        }

        return $data;
    }

    public function getData($key = null)
    {
        $data = parent::getData($key); // TODO: Change the autogenerated stub
        $type = $this->getType();
        foreach ($data as $k => $v) {
            if (!is_object($v) || !($v instanceof manufactoryCostEntity)) {
                $data[$k] = $type->buildEntityCost($this->getEntity(), array('cost_id' => $k, 'quantity' => $v));
            }
        }

        return $data;
    }

    protected function getType()
    {
        return $this->getFactory('Costs')
            ->getType($this->getEntityType());
    }

    public function getPrice()
    {
        $price = 0.0;
        foreach ($this->data as $item) {
            $price += $item->getPrice($this->getEntity()->getSkuData());
        }

        return $price;
    }
}